#!/bin/bash

#version: 0.11

#user setting
XML_RD_SET_SEPARATOR='='
XML_RD_SET_NODE_SEPARATOR='.'
XML_RD_SET_ATTR_SEPARATOR='@'
XML_RD_SET_COMMENT='#'
XML_RD_SET_ROOT='xml'

#output data (read only)
XML_RD_TAG_NAME=''
XML_RD_CONTENT=''
XML_RD_ATTRIBUTES=''
XML_RD_TAG_COMPLETED=0
XML_RD_ATTR_COMPLETED=0
XML_RD_TAG_CONTEINER=0
XML_RD_ENTITY=''
XML_RD_RSTATE=0
XML_RD_PATH=''
XML_RD_FNODE=''


#process data (read only)
XML_RD_NODE_INDEX=0
XML_RD_NODES=( "$XML_RD_SET_ROOT" )

#1st replaze &amp; &quot; &gt; &lt; \n to \\n and <new line> to \n
function xml_replace_entity(){
  local v="$1"
  v="${v//&lt;/<}"
  v="${v//&gt;/>}"
  v="${v//&quot;/\"}"
  v="${v//&amp;/&}"
  v="${v//\\/\\\\}"
  echo "${v//$'\n'/\\n}"
}

XML_READ_VALUE_ONLY=0
function prv_xml_read_get_pathname(){
  local IFS="$XML_RD_SET_NODE_SEPARATOR"
  XML_RD_PATH="${XML_RD_NODES[*]}"
  if [[ "${XML_RD_TAG_COMPLETED}" == 1 ]]; then
    XML_RD_PATH="${XML_RD_PATH}${XML_RD_SET_NODE_SEPARATOR}${XML_RD_TAG_NAME}${XML_RD_SET_SEPARATOR}"  
  else
    XML_RD_PATH="${XML_RD_PATH}${XML_RD_SET_SEPARATOR}" 
  fi
  XML_RD_PATH2="${XML_RD_NODES[*]}${XML_RD_SET_NODE_SEPARATOR}${XML_RD_TAG_NAME}${XML_RD_SET_SEPARATOR}"
  if [[ "$XML_READ_VALUE_ONLY" = "1" ]]; then
    XML_RD_FNODE="$(xml_replace_entity "${XML_RD_CONTENT}")"
  else
    XML_RD_FNODE="${XML_RD_PATH}$(xml_replace_entity "${XML_RD_CONTENT}")"
  fi
}

XML_RD_ATTR_FILTER=''
function prv_xml_read_parse_attr(){
  local IFS="$XML_RD_SET_NODE_SEPARATOR"
  local var="${XML_RD_ATTRIBUTES}"
  while [[ -n "${var}"  ]]; do
    local var="${var#"${var%%[![:space:]]*}"}"
    key="${var%%=*}"
    key="${key%"${key##*[![:space:]]}"}"
    if [[ -n "${key}" ]]; then
      var="${var#*=}"
      #attr value have to be quoted
      var="${var#"${var%%[![:space:]]*}"}"
      local quot='"'
      if [[ "${var:0:1}" = "'" ]]; then
        quot="'"
      else
        if [[ "${var:0:1}" != '"' ]]; then
          echo "......error, exit 4"
          exit 4
        fi
      fi
      var="${var:1}"
      local value="${var%%${quot}*}"
      var="${var#*${quot}}"
      local ATTR="$(xml_replace_entity "${value}")"
      if [[ -n "$XML_RD_ATTR_FILTER" ]]; then
        if [[ "$XML_RD_ATTR_FILTER" != "${key}" ]]; then
          continue
        fi
      fi
      if [[ "$XML_READ_VALUE_ONLY" = "1" ]]; then
        echo "$ATTR"
      else
        if [[ "${XML_RD_RSTATE}" = 'tag-only' ]]; then
          echo  "${XML_RD_NODES[*]}${XML_RD_SET_ATTR_SEPARATOR}$key${XML_RD_SET_SEPARATOR}$ATTR"
        else
          echo  "${XML_RD_NODES[*]}${XML_RD_SET_NODE_SEPARATOR}${XML_RD_TAG_NAME}${XML_RD_SET_ATTR_SEPARATOR}$key${XML_RD_SET_SEPARATOR}$ATTR"
        fi
      fi
    fi
  done
}

#read next node/item
function prv_xml_read_dom(){
  XML_RD_CONTENT="${XML_RD_NODE_NO_CONTENT}"
  XML_RD_TAG_COMPLETED=0
  XML_RD_ATTR_IS_COMPLETED=0
  old_rstate="XML_RD_RSTATE"
  XML_RD_RSTATE=0
  local IFS=''
  read -r -d \> XML_RD_ENTITY
  local RET=$?
###  local var="$(echo -e "$XML_RD_ENTITY" | sed -e ':a;N;$!ba;s/^[ \t\r\n]*//')"
  local var="${XML_RD_ENTITY#"${XML_RD_ENTITY%%[![:space:]]*}"}"
  if [[ -n "$var" ]]; then
    local var2="${XML_RD_ENTITY##*<}"
    if [[ "${var:0:1}" != "<" && "${var2:0:1}" != '/' ]]; then
      #ignore conteiner text
      var="<${XML_RD_ENTITY##*<}"
    fi
    if [[ "${var:0:1}" = "<" ]]; then    
      #a tag
      if [[ "${var:1:1}" = '!' ]]; then
        #comment tag
        XML_RD_RSTATE='comment'
        XML_RD_CONTENT="${var#<\!--}"
        XML_RD_CONTENT="${XML_RD_CONTENT%--}"
        XML_RD_TAG_NAME="$XML_RD_SET_COMMENT"
        XML_RD_TAG_COMPLETED=1
      else
        if [[ "${var:1:1}" = '?' ]]; then
          #xml tag
          XML_RD_RSTATE='xml'
          XML_RD_CONTENT="${var#<\?}"
          XML_RD_CONTENT="${XML_RD_CONTENT%\?}"
          XML_RD_TAG_NAME=''
          XML_RD_TAG_COMPLETED=1
        else
          if [[ "${var:1:1}" = '/' ]]; then
            #end tag of content without value, end of conteiner
            XML_RD_TAG_NAME="${var:2}"
            if [[ "${XML_RD_NODES[$XML_RD_NODE_INDEX]}" != "$XML_RD_TAG_NAME"  ]]; then
              echo "......error, exit 3"
              exit 3
            fi
            unset XML_RD_NODES[$XML_RD_NODE_INDEX]
            XML_RD_NODE_INDEX=$(($XML_RD_NODE_INDEX-1))
            XML_RD_RSTATE='tag-long'
            XML_RD_TAG_COMPLETED=1
          else
            XML_RD_TAG_NAME="${var%% *}"
            XML_RD_TAG_NAME="${XML_RD_TAG_NAME:1}"
            XML_RD_ATTRIBUTES="${var#* }"
            XML_RD_ATTRIBUTES="${XML_RD_ATTRIBUTES#"${XML_RD_ATTRIBUTES%%[![:space:]]*}"}"
            if [[ "${var:(-1)}" = "/" ]]; then
              #short tag
              XML_RD_RSTATE='tag-short'
              XML_RD_TAG_NAME="${XML_RD_TAG_NAME%/}"
              XML_RD_ATTRIBUTES="${XML_RD_ATTRIBUTES%/}"
              XML_RD_TAG_COMPLETED=1
            else
              #tag only - conteiner
              XML_RD_RSTATE='tag-only'
              XML_RD_NODE_INDEX=$(($XML_RD_NODE_INDEX+1))
              XML_RD_NODES[${XML_RD_NODE_INDEX}]="${XML_RD_TAG_NAME}"
            fi
            if [[ -n "$XML_RD_ATTRIBUTES" && "${XML_RD_ATTRIBUTES:0:1}" != '<' ]]; then
              XML_RD_ATTR_IS_COMPLETED=1
            fi
          fi
        fi
      fi
    else
      #value of tag
      XML_RD_RSTATE='tag-long'
      XML_RD_CONTENT="${XML_RD_ENTITY%<*}"
      var="${XML_RD_ENTITY##*<}"
      if [[ "${var:0:1}" = '/' ]]; then
        var="${var:1}"
        if [[ "${XML_RD_NODES[$XML_RD_NODE_INDEX]}" != "$var"  ]]; then
          echo "......error, exit 3"
          exit 3
        fi
        XML_RD_TAG_NAME="${XML_RD_NODES[${XML_RD_NODE_INDEX}]}"
	unset XML_RD_NODES[${XML_RD_NODE_INDEX}]
        XML_RD_NODE_INDEX=$(($XML_RD_NODE_INDEX-1))
        XML_RD_TAG_COMPLETED=1
      else
        echo "......error, exit 5"
        exit 5
      fi
    fi
  fi
  return $RET
}

XML_TO_PLAIN_PRINT_TAGS=1
XML_TO_PLAIN_PRINT_ATTR=1

#1st arg input xml file
#2st filter entity name (optional)
#3nd filter entitty order number 1st occurence = 1, 2nd occurence = 2 ...
function xml_to_plain(){
  XML_RD_NODE_INDEX=0
  XML_RD_NODES=( "$XML_RD_SET_ROOT" )
  XML_RD_RSTATE=0
  XML_RD_PATH=''
  XML_RD_FNODE=''
  if [[ -n "$2" ]]; then
    local len=${#2}
    if [[ -n "$3" ]]; then
      local num=$(($3+0))
      local iter=1
      while prv_xml_read_dom; do
        prv_xml_read_get_pathname
        local var2="${XML_RD_PATH:0:$len}"
        if [[ "${var2}" = "${2}" ]]; then
          if [[ "$num" -eq "$iter" ]]; then
            if [[ "$XML_RD_TAG_COMPLETED" = "1" && "$XML_TO_PLAIN_PRINT_TAGS" = "1" ]]; then
              echo "$XML_RD_FNODE"
            fi
            if [[ "$XML_RD_ATTR_IS_COMPLETED" = "1" && "$XML_TO_PLAIN_PRINT_ATTR" = "1" ]]; then
              prv_xml_read_parse_attr
            fi
          fi
          if [[ "${2:(-1)}" = "=" ]]; then
            local var3="${2}"
            var2="${XML_RD_PATH2:0:$(($len))}"
          else
            local var3="${2}="
            var2="${XML_RD_PATH2:0:$(($len+1))}"
          fi 
          if [[ "$var2" = "${var3}" ]]; then
            iter=$(($iter+1))
            if [[ "$iter" -lt "$num" ]]; then
              return 0
            fi
          fi
        fi
      done < "$1"
    else
      while prv_xml_read_dom; do
        prv_xml_read_get_pathname
        local var2="${XML_RD_PATH:0:$len}"
        if [[ "${var2}" = "${2}" ]]; then
          if [[ "$XML_RD_TAG_COMPLETED" = "1" && "$XML_TO_PLAIN_PRINT_TAGS" = "1" ]]; then
            echo "$XML_RD_FNODE"
          fi
          if [[ "$XML_RD_ATTR_IS_COMPLETED" = "1" && "$XML_TO_PLAIN_PRINT_ATTR" = "1" ]]; then
            prv_xml_read_parse_attr
          fi
        fi
      done < "$1"
    fi
  else
   while prv_xml_read_dom; do
      if [[ "$XML_RD_TAG_COMPLETED" = "1" && "$XML_TO_PLAIN_PRINT_TAGS" = "1" ]]; then
        prv_xml_read_get_pathname
        echo "$XML_RD_FNODE"
      fi
      if [[ "$XML_RD_ATTR_IS_COMPLETED" = "1" && "$XML_TO_PLAIN_PRINT_ATTR" = "1" ]]; then
        prv_xml_read_parse_attr
      fi
    done < "$1"
  fi
  return 0
}

#1st arg input xml file
#2st filter entity name (optional)
#3nd filter entitty order number 1st occurence = 1, 2nd occurence = 2 ...
#xml_to_plain "$1" "$2" $3 
